<?php
abstract class WPSunshine_Data {

    protected $id = 0;
    protected $data = array();
    protected $meta = array();
    protected $type;

    public function __get( $key ) {
        if ( array_key_exists( $key, $this->meta ) ) {
            return $this->meta[ $key ];
        } else {
            return get_post_meta( $this->id, $key, true );
        }
        return null;
    }

    public function show_data() {
        echo '<pre>';
        var_dump( $this->data );
        echo '</pre>';
    }

    public function get_data() {
        return array_merge( array( 'id' => $this->get_id() ), $this->data, array( 'meta_data' => $this->get_meta_data() ) );
    }

    public function get_meta_data() {
        if ( empty( $this->meta ) ) {
            $this->set_meta_data();
        }
        return $this->meta;
    }

    public function update_meta_data() {
        foreach ( $this->meta as $key => $value ) {
            update_post_meta( $this->id, $key, $value );
        }
    }

    public function set_meta_data() {
        $meta = get_post_meta( $this->id );
        foreach ( $meta as $key => $value ) {
            if ( !empty( $value ) ) {
                if ( count( $value ) == 1 ) {
                    $this->meta[ $key ] = $value[ 0 ];
                } else {
                    $this->meta[ $key ] = array();
                    foreach ( $meta[ $key ] as $item ) {
                        $this->meta[ $key ][] = $item;
                    }
                }
            }
        }
    }

    public function get_id() {
        return $this->id;
    }

    public function get_meta_value( $key ) {
        if ( empty( $this->meta ) ) {
            $this->set_meta_data();
        }
        if ( array_key_exists( $key, $this->meta ) ) {
            return $this->meta[ $key ];
        }
        return false;
    }

    public function update_meta_value( $key, $value ) {
        $this->meta[ $key ] = $value;
        update_post_meta( $this->id, $key, $value );
    }

    public function save() {

        if ( $this->get_id() > 0 ) {
            $this->update( $this );
        } else {
            $this->create( $this );
        }

    }

    public function update() { }

    public function create() { }

    public function delete() { }

}
