<?php
class WPSunshine_Order extends WPSunshine_Data {

    protected $type = 'sunshine-order';
    protected $order_data = array();

    public function __construct( $object ) {

        if ( is_numeric( $object ) ) {
            $this->id = $object;
            if ( $object > 0 ) {
                $post = get_post( $object );
                if ( empty( $post ) || $post->post_type != $this->type ) { return false; }
                $this->id = $post->ID;
                $this->data = $post;
                if ( $post->post_title ) {
                    $this->name = $post->post_title;
                }
            }
        } elseif ( is_a( $object, 'WP_Post' ) ) {
            if ( $object->post_type != $this->type ) { return false; }
            $this->data = $object;
            $this->id = $object->ID;
        }

        if ( $this->id > 0 ) {
            $this->set_order_data();
        }

    }

    public function set_order_data() {
        $this->order_data = maybe_unserialize( get_post_meta( $this->id, '_sunshine_order_data', true ) );
    }

    // Return a WP_User for the user tied to this order
    function get_user() {

    }

    // Return a WPSunshine_Customer for user tied to this order
    function get_customer() {

    }

    public function get_prop( $key ) {
        if ( array_key_exists( $key, $this->order_data ) ) {
            return $this->order_data[ $key ];
        }
    }

    public function get_billing_first_name() {
        return $this->get_prop( 'first_name' );
    }

    public function get_billing_last_name() {
        return $this->get_prop( 'last_name' );
    }

    public function get_billing_address1() {
        return $this->get_prop( 'address' );
    }

    public function get_billing_address2() {
        return $this->get_prop( 'address2' );
    }

    public function get_billing_city() {
        return $this->get_prop( 'city' );
    }

    public function get_billing_state() {
        return $this->get_prop( 'state' );
    }

    public function get_billing_zip() {
        return $this->get_prop( 'zip' );
    }

    public function get_billing_country() {
        return $this->get_prop( 'country' );
    }

    public function get_shipping_first_name() {
        return $this->get_prop( 'shipping_first_name' );
    }

    public function get_shipping_last_name() {
        return $this->get_prop( 'shipping_last_name' );
    }

    public function get_shipping_address1() {
        return $this->get_prop( 'shipping_address' );
    }

    public function get_shipping_address2() {
        return $this->get_prop( 'shipping_address2' );
    }

    public function get_shipping_city() {
        return $this->get_prop( 'shipping_city' );
    }

    public function get_shipping_state() {
        return $this->get_prop( 'shipping_state' );
    }

    public function get_shipping_zip() {
        return $this->get_prop( 'shipping_zip' );
    }

    public function get_shipping_country() {
        return $this->get_prop( 'shipping_country' );
    }

    public function get_total() {
        return $this->get_prop( 'total' );
    }

    public function get_tax() {
        return $this->get_prop( 'tax' );
    }

    public function get_shipping_cost() {
        return $this->get_prop( 'shipping_cost' );
    }

    public function get_shipping_method() {
        return $this->get_prop( 'shipping_method' );
    }

    public function get_shipping_method_name() {
        return sunshine_get_shipping_method_name( $this->get_shipping_method() );
    }

    public function get_payment_method() {
        return $this->get_prop( 'payment_method' );
    }

    public function get_payment_method_name() {
        return SunshinePaymentMethods::method_name( $this->get_payment_method() );
    }


    public function get_date() {
        return date( get_option( 'date_format' ), strtotime( $this->data->post_date ) );
    }

    public function get_status() {
        $current_status = array_values( get_the_terms( $this->get_id(), 'sunshine-order-status' ) );
        if ( !empty( $current_status ) ) {
            return $current_status[0]->name;
        }
        return false;
    }

    public function get_items() {
        $items = maybe_unserialize( get_post_meta( $this->get_id(), '_sunshine_order_items', true ) );
        return $items;
    }
}
